/*******************************************************************************
 * Copyright (c) 2010 IGA Tosiki, NTT DATA BUSINESS BRAINS Corp.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    IGA Tosiki (NTT DATA BUSINESS BRAINS Corp.) - initial API and implementation
 *******************************************************************************/
/*
 * blanco Framework
 * Copyright (C) 2004-2010 IGA Tosiki
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 */
package blanco.plugin.service.editors;

import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.PrintWriter;
import java.io.StringWriter;
import java.net.URL;

import javax.xml.transform.dom.DOMResult;

import org.eclipse.core.resources.IFile;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.jface.dialogs.IInputValidator;
import org.eclipse.jface.dialogs.InputDialog;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;
import org.eclipse.ui.IFileEditorInput;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;

import blanco.commons.util.BlancoNameUtil;
import blanco.commons.util.BlancoXmlUtil;
import blanco.plugin.service.BlancoServicePlugin;
import blanco.plugin.service.BlancoServicePluginConstants;
import blanco.plugin.service.actions.BlancoServiceGenerateAction;
import blanco.service.BlancoServiceConstants;
import blanco.service.resourcebundle.BlancoServiceResourceBundle;

/**
 * エディタ <br>
 * 
 * @author iga
 */
public class BlancoServiceEditor extends AbstractBlancoServiceEditor {
    private static final BlancoServiceResourceBundle fBundle = new BlancoServiceResourceBundle();

    private Composite top = null;

    // ビジュアル領域
    private Label labelBlancoTitle = null;

    private Label labelBlancoSettingId = null;

    private Text textBlancoSettingId = null;

    private Label labelMetadir = null;

    private Text textMetadir = null;

    private Label labelMetadirComment = null;

    private Label labelSettingComment = null;

    private Button buttonExecuteJavaSource = null;

    private Button buttonCreateMetafile = null;

    public void createPartControl(Composite parent) {
        top = parent;
        top.setSize(new org.eclipse.swt.graphics.Point(1000, 400));

        GridLayout layout = new GridLayout();
        layout.numColumns = 2;
        top.setLayout(layout);

        // スペーサー
        new Label(top, SWT.NONE).setText("");

        labelBlancoTitle = new Label(top, SWT.NONE);
        labelBlancoTitle.setText(BlancoServiceConstants.PRODUCT_NAME
                + " 設定ファイル エディタ (" + BlancoServiceConstants.VERSION + ")");

        // スペーサー
        new Label(top, SWT.NONE).setText("");

        // スペーサー
        new Label(top, SWT.NONE).setText("");

        labelBlancoSettingId = new Label(top, SWT.NONE);
        labelBlancoSettingId.setText("設定ID");
        textBlancoSettingId = new Text(top, SWT.BORDER);
        textBlancoSettingId.setText(BlancoServiceConstants.PRODUCT_NAME);
        textBlancoSettingId.setEditable(false);

        labelMetadir = new Label(top, SWT.NONE);
        labelMetadir.setText("メタディレクトリ");

        textMetadir = new Text(top, SWT.BORDER);
        textMetadir
                .setText("meta" + BlancoServiceConstants.TARGET_SUBDIRECTORY);

        // スペーサー
        new Label(top, SWT.NONE).setText("");

        labelMetadirComment = new Label(top, SWT.NONE);
        labelMetadirComment.setText("※メタディレクトリは通常変更せずに利用します。");
        labelMetadirComment.setSize(new org.eclipse.swt.graphics.Point(500,
                30 + 20));

        // スペーサー
        new Label(top, SWT.NONE).setText("");

        buttonCreateMetafile = new Button(top, SWT.NONE);
        buttonCreateMetafile
                .setText(fBundle.getMetafileDisplayname() + " 新規作成");
        buttonCreateMetafile
                .addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
                    public void widgetSelected(
                            org.eclipse.swt.events.SelectionEvent e) {
                        // メタファイル作成の際には、他の項目のチェックは行いません。
                        saveToTextEditor();

                        if (textMetadir.getText().length() == 0) {
                            MessageDialog
                                    .openWarning(
                                            top.getShell(),
                                            fBundle.getMetafileDisplayname()
                                                    + " 新規作成",
                                            "メタディレクトリ名を指定してください。\n"
                                                    + "※メタディレクトリ名の一般的な設定値は 'meta"
                                                    + BlancoServiceConstants.TARGET_SUBDIRECTORY
                                                    + "' です。");
                            return;
                        }

                        final IFileEditorInput input = (IFileEditorInput) getEditorInput();

                        try {
                            if (BlancoServicePluginUtil.findFolder(
                                    input.getFile(), getProgressMonitor(),
                                    textMetadir.getText()).exists() == false) {
                                BlancoServicePluginUtil.createFolder(input
                                        .getFile(), getProgressMonitor(),
                                        textMetadir.getText());

                                MessageDialog.openInformation(top.getShell(),
                                        "メタディレクトリの作成", "メタディレクトリ ["
                                                + textMetadir.getText()
                                                + "] を新規に作成しました。\n"
                                                + "※初回にのみ必要な動作です。");
                            }
                        } catch (CoreException e3) {
                            MessageDialog.openWarning(top.getShell(), fBundle
                                    .getMetafileDisplayname()
                                    + " 新規作成", "メタディレクトリ作成に失敗しました。処理中断します。:"
                                    + e3.toString());
                            e3.printStackTrace();
                            return;
                        }

                        InputStream inStream = null;
                        try {
                            final URL localURL = BlancoServicePlugin
                                    .getPluginRoot();

                            InputDialog inputDialog = new InputDialog(top
                                    .getShell(), fBundle
                                    .getMetafileDisplayname()
                                    + " 新規作成", fBundle.getMetafileDisplayname()
                                    + "をメタディレクトリ[" + textMetadir.getText()
                                    + "]に作成します。"
                                    + fBundle.getMetafileDisplayname()
                                    + "の新規ファイル名を入力してください。",
                                    BlancoServiceConstants.PRODUCT_NAME
                                            + "Meta.xls",
                                    new IInputValidator() {
                                        public String isValid(String newText) {
                                            if (newText.endsWith(".xls") == false) {
                                                return "ファイル名は .xlsで終了するように指定してください。";
                                            }
                                            if (BlancoNameUtil
                                                    .isValidFileName(newText) == false) {
                                                return "ファイル名には "
                                                        + BlancoNameUtil
                                                                .invalidFileNameChar()
                                                        + " は利用しないでください。";
                                            }
                                            // 既にそのファイルが存在しないかどうかをチェック
                                            IFile newFileMeta = input.getFile()
                                                    .getProject().getFolder(
                                                            textMetadir
                                                                    .getText())
                                                    .getFile(newText);
                                            if (newFileMeta.exists()) {
                                                return "指定のファイルは既に存在しています。"
                                                        + "別のファイル名を指定してください。";
                                            }
                                            return null;
                                        }
                                    });
                            if (inputDialog.open() == InputDialog.CANCEL) {
                                inputDialog.close();
                                return;
                            }
                            final String newMetaFilename = inputDialog
                                    .getValue();
                            inputDialog.close();

                            // プラグインのローカルからテンプレートを読み込みます。
                            inStream = new FileInputStream(
                                    localURL.getPath()
                                            + BlancoServicePluginConstants.TEMPLATE_FILENAME_WITHOUT_EXT
                                            + ".xls");
                            IFile newFileMeta = input.getFile().getProject()
                                    .getFolder(textMetadir.getText()).getFile(
                                            newMetaFilename);
                            newFileMeta.create(inStream, true,
                                    getProgressMonitor());
                            MessageDialog.openInformation(top.getShell(),
                                    fBundle.getMetafileDisplayname() + " 新規作成",
                                    fBundle.getMetafileDisplayname() + " ["
                                            + newMetaFilename + "] をメタディレクトリ["
                                            + textMetadir.getText()
                                            + "]に新規作成しました。\n"
                                            + "このファイルを編集して、関連情報を設定してください。");
                        } catch (CoreException e1) {
                            e1.printStackTrace();
                            return;
                        } catch (IOException e2) {
                            MessageDialog.openWarning(top.getShell(), "メタファイル",
                                    "メタファイルのコピーに失敗しました。:" + e2.toString());
                            e2.printStackTrace();
                        } finally {
                            if (inStream != null) {
                                try {
                                    inStream.close();
                                } catch (IOException e1) {
                                    e1.printStackTrace();
                                }
                            }
                        }

                    }
                });

        // スペーサー
        new Label(top, SWT.NONE).setText("");

        buttonExecuteJavaSource = new Button(top, SWT.NONE);
        buttonExecuteJavaSource.setText("Javaソースコード生成");
        buttonExecuteJavaSource
                .addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
                    public void widgetSelected(
                            org.eclipse.swt.events.SelectionEvent e) {
                        if (checkInputField() == false) {
                            return;
                        }

                        try {
                            if (checkInputField() == false) {
                                return;
                            }

                            final IFileEditorInput input = (IFileEditorInput) getEditorInput();
                            if (input.getFile().getProject().getFolder(
                                    textMetadir.getText()).exists() == false) {
                                MessageDialog.openWarning(top.getShell(),
                                        "Javaソースコード生成", "メタディレクトリ ("
                                                + textMetadir.getText()
                                                + ") が存在しません。処理を中断します。");
                                return;
                            }

                            showBusy(true);
                            // 再入を防止するために必要です。
                            buttonExecuteJavaSource.setEnabled(false);

                            String metaDir = textMetadir.getText();
                            if (metaDir.trim().length() == 0) {
                                metaDir = null;
                            }
                            BlancoServiceGenerateAction
                                    .processBlancoServiceSource(
                                            input.getFile(), top.getShell(),
                                            getProgressMonitor(), metaDir);

                            // blancoフォルダを同期
                            BlancoServicePluginUtil.refreshFolder(input
                                    .getFile(), getProgressMonitor(), "blanco");

                            // tmpフォルダを同期
                            BlancoServicePluginUtil.refreshFolder(input
                                    .getFile(), getProgressMonitor(), "tmp");

                            // フォルダを同期
                            // あくまでも保険として同期を取ります。
                            BlancoServicePluginUtil.refreshFolder(input
                                    .getFile(), getProgressMonitor(),
                                    textMetadir.getText());
                        } catch (Exception ex) {
                            ex.printStackTrace();
                            StringWriter writer = new StringWriter();
                            ex.printStackTrace(new PrintWriter(writer));
                            writer.flush();
                            MessageDialog.openError(top.getShell(),
                                    "Javaソースコード生成", "回復不能なエラーが発生.:"
                                            + ex.toString() + ": "
                                            + writer.toString());
                        } finally {
                            showBusy(false);
                            // 再入を防止するために必要です。
                            buttonExecuteJavaSource.setEnabled(true);
                        }
                    }

                });

        // スペーサー
        new Label(top, SWT.NONE).setText("");

        labelSettingComment = new Label(top, SWT.NONE);
        labelSettingComment.setText("※各々の設定値は "
                + BlancoServicePluginConstants.TARGET_FILENAME
                + "ファイルに平文で格納されます。");
        labelSettingComment
                .setSize(new org.eclipse.swt.graphics.Point(500, 20));

        loadFromTextEditor();

        setFocusLostHandler(textMetadir);
    }

    /**
     * 入力項目のチェックを実施します。 <br>
     * エラーダイアログはこのメソッドで表示します。
     * 
     * @return
     */
    private final boolean checkInputField() {
        boolean isError = false;
        if (textMetadir.getText().length() == 0) {
            textMetadir.setBackground(top.getDisplay().getSystemColor(
                    SWT.COLOR_YELLOW));
            isError = true;
        } else {
            textMetadir.setBackground(top.getDisplay().getSystemColor(
                    SWT.COLOR_INFO_BACKGROUND));
        }

        if (isError) {
            MessageDialog.openWarning(top.getShell(), "必須項目への入力が足りません",
                    "必須項目への入力が足りません。\nハイライト表示されている必須項目に値を入力してください");
        }

        return !isError;
    }

    protected void loadFromTextEditorInternal(DOMResult argResult) {
        final Node nodeRoot = argResult.getNode();
        if (nodeRoot == null) {
            return;
        }
        final Element elementBlancoService = BlancoXmlUtil.getElement(nodeRoot,
                "blanco/target/" + BlancoServiceConstants.PRODUCT_NAME_LOWER);
        if (elementBlancoService == null) {
            return;
        }

        final String metadir = elementBlancoService.getAttribute("metadir");
        if (metadir != null) {
            textMetadir.setText(metadir);
        }
    }

    /**
     * 保存処理を行います。
     */
    public Document saveToTextEditorInternal() {
        String metadir = null;
        if (textMetadir.getText().trim().length() > 0) {
            metadir = textMetadir.getText();
        }

        final Document document = BlancoXmlUtil.newDocument();
        final Element eleBlanco = document.createElement("blanco");
        document.appendChild(eleBlanco);

        final Element eleTarget = document.createElement("target");
        eleTarget.setAttribute("name", textBlancoSettingId.getText());
        eleBlanco.appendChild(eleTarget);

        final Element eleBlancoService = document
                .createElement(BlancoServiceConstants.PRODUCT_NAME_LOWER);
        eleTarget.appendChild(eleBlancoService);

        if (metadir != null) {
            eleBlancoService.setAttribute("metadir", metadir);
        }

        return document;
    }
}